var L = Object.defineProperty;
var M = (r, s, e) => s in r ? L(r, s, { enumerable: !0, configurable: !0, writable: !0, value: e }) : r[s] = e;
var w = (r, s, e) => (M(r, typeof s != "symbol" ? s + "" : s, e), e);
const f = globalThis.process ?? { env: {}, versions: {} }, C = { ...f == null ? void 0 : f.env }, W = {
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  node: "unknown",
  ...f == null ? void 0 : f.versions
}, Re = (f == null ? void 0 : f.platform) ?? "unknown", je = (f == null ? void 0 : f.arch) ?? "unknown";
class p extends Error {
  constructor(e, t) {
    super(e);
    w(this, "code");
    w(this, "stack");
    w(this, "context");
    this.context = t, t instanceof Error && (this.name = t.name, this.stack = t.stack, "code" in t && typeof t.code == "string" && (this.code = t.code));
  }
}
const G = [
  {
    url: "{scheme}://{host}{basePath}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api.browserstack.com"
      },
      basePath: {
        default: "/5"
      }
    }
  },
  {
    url: "{scheme}://{host}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api-cloud.browserstack.com"
      }
    }
  }
], N = "browserstack-client", F = "3.5.4", _ = "BrowserStack APIs client library for node.js", K = "module", Q = "./dist/browserstack-client.umd.cjs", V = {
  "browserstack-local": "./dist/node/browserstack-local.cjs",
  "browserstack-app-automate": "./dist/node/browserstack-app-automate.cjs"
}, J = "./dist/browserstack-client.js", Y = "./dist/types/index.d.ts", X = {
  ".": {
    types: "./dist/types/index.d.ts",
    import: "./dist/browserstack-client.js",
    require: "./dist/browserstack-client.umd.cjs"
  },
  "./node": {
    types: "./dist/types/index.node.d.ts",
    import: "./dist/node/browserstack-client.js",
    require: "./dist/node/browserstack-client.cjs"
  },
  "./package.json": "./package.json",
  "./*": "./dist/*"
}, Z = {
  prebuild: "node build.mjs && npm run lint",
  build: "tsc && vite build && vite build --config vite.config.node.ts",
  test: "vitest run --typecheck",
  "test-watch": "vitest --typecheck",
  coverage: "vitest run --coverage.enabled --coverage.include=src --coverage.exclude=src/generated",
  lint: "eslint . --ext .ts",
  "predocs:dev": "typedoc",
  "docs:dev": "vitepress dev docs",
  "predocs:build": "typedoc",
  "docs:build": "vitepress build docs",
  "docs:preview": "vitepress preview docs",
  "generate:java": "npx @openapitools/openapi-generator-cli generate --generator-key java",
  "generate:kotlin": "npx @openapitools/openapi-generator-cli generate --generator-key kotlin",
  "generate:csharp": "npx @openapitools/openapi-generator-cli generate --generator-key csharp",
  "generate:ruby": "npx @openapitools/openapi-generator-cli generate --generator-key ruby"
}, ee = "Shirish Kamath", te = "MIT", se = [
  "dist/**/*",
  "*.d.ts"
], re = {
  node: ">=18.0.0"
}, ne = {
  "@apidevtools/swagger-parser": "^10.1.0",
  "@types/node": "^20.11.19",
  "@typescript-eslint/eslint-plugin": "^7.0.1",
  "@typescript-eslint/parser": "^7.0.1",
  "@vitest/coverage-v8": "1.2.1",
  eslint: "^8.56.0",
  "openapi-typescript": "^7.0.0-next.7",
  "openapi-typescript-helpers": "^0.0.7",
  typedoc: "^0.25.9",
  "typedoc-plugin-markdown": "^4.0.0-next.43",
  "typedoc-vitepress-theme": "^1.0.0-next.9",
  typescript: "^5.3.3",
  vite: "^5.1.4",
  "vite-plugin-dts": "^3.7.3",
  vitepress: "^1.0.0-rc.44",
  vitest: "1.2.1"
}, ae = {
  fflate: "^0.8.2",
  "openapi-fetch": "0.9.2",
  "signal-exit": "^4.1.0"
}, ie = {
  type: "git",
  url: "git://github.com/shirish87/browserstack-client.git"
}, oe = "https://shirish87.github.io/browserstack-client/", ce = {
  url: "https://github.com/shirish87/browserstack-client/issues"
}, le = [
  "browserstack",
  "api",
  "client",
  "node",
  "javascript",
  "typescript",
  "esm"
], u = {
  name: N,
  version: F,
  description: _,
  type: K,
  main: Q,
  bin: V,
  module: J,
  types: Y,
  exports: X,
  scripts: Z,
  author: ee,
  license: te,
  files: se,
  engines: re,
  devDependencies: ne,
  dependencies: ae,
  repository: ie,
  homepage: oe,
  bugs: ce,
  keywords: le
}, de = [u == null ? void 0 : u.name, u == null ? void 0 : u.version].filter(Boolean).join("/"), ue = ["node", W.node].filter(Boolean).join("/"), fe = [de, ue].filter(Boolean).join(" "), pe = {
  name: u == null ? void 0 : u.name,
  version: u == null ? void 0 : u.version,
  userAgent: fe
}, he = {
  "Content-Type": "application/json"
}, ye = /\{[^{}]+\}/g;
function O(r) {
  let {
    baseUrl: s = "",
    fetch: e = globalThis.fetch,
    querySerializer: t,
    bodySerializer: n,
    headers: a,
    ...o
  } = { ...r };
  s.endsWith("/") && (s = s.substring(0, s.length - 1)), a = z(he, a);
  const c = [];
  async function h(l, i) {
    let {
      fetch: g = e,
      headers: H,
      params: E = {},
      parseAs: $ = "json",
      querySerializer: v,
      bodySerializer: x = n ?? be,
      ...I
    } = i || {}, q = typeof t == "function" ? t : U(t);
    v && (q = typeof v == "function" ? v : U({
      ...typeof t == "object" ? t : {},
      ...v
    }));
    const b = {
      redirect: "follow",
      ...o,
      ...I,
      headers: z(a, H, E.header)
    };
    b.body && (b.body = x(b.body)), b.body instanceof FormData && b.headers.delete("Content-Type");
    let k = new Request(
      we(l, { baseUrl: s, params: E, querySerializer: q }),
      b
    );
    const P = {
      baseUrl: s,
      fetch: g,
      parseAs: $,
      querySerializer: q,
      bodySerializer: x
    };
    for (const y of c)
      if (y && typeof y == "object" && typeof y.onRequest == "function") {
        k.schemaPath = l, k.params = E;
        const m = await y.onRequest(k, P);
        if (m) {
          if (!(m instanceof Request))
            throw new Error(
              "Middleware must return new Request() when modifying the request"
            );
          k = m;
        }
      }
    let d = await g(k);
    for (let y = c.length - 1; y >= 0; y--) {
      const m = c[y];
      if (m && typeof m == "object" && typeof m.onResponse == "function") {
        const T = await m.onResponse(d, P);
        if (T) {
          if (!(T instanceof Response))
            throw new Error(
              "Middleware must return new Response() when modifying the response"
            );
          d = T;
        }
      }
    }
    if (d.status === 204 || d.headers.get("Content-Length") === "0")
      return d.ok ? { data: {}, response: d } : { error: {}, response: d };
    if (d.ok)
      return $ === "stream" ? { data: d.body, response: d } : { data: await d[$](), response: d };
    let S = await d.text();
    try {
      S = JSON.parse(S);
    } catch {
    }
    return { error: S, response: d };
  }
  return {
    /** Call a GET endpoint */
    async GET(l, i) {
      return h(l, { ...i, method: "GET" });
    },
    /** Call a PUT endpoint */
    async PUT(l, i) {
      return h(l, { ...i, method: "PUT" });
    },
    /** Call a POST endpoint */
    async POST(l, i) {
      return h(l, { ...i, method: "POST" });
    },
    /** Call a DELETE endpoint */
    async DELETE(l, i) {
      return h(l, { ...i, method: "DELETE" });
    },
    /** Call a OPTIONS endpoint */
    async OPTIONS(l, i) {
      return h(l, { ...i, method: "OPTIONS" });
    },
    /** Call a HEAD endpoint */
    async HEAD(l, i) {
      return h(l, { ...i, method: "HEAD" });
    },
    /** Call a PATCH endpoint */
    async PATCH(l, i) {
      return h(l, { ...i, method: "PATCH" });
    },
    /** Call a TRACE endpoint */
    async TRACE(l, i) {
      return h(l, { ...i, method: "TRACE" });
    },
    /** Register middleware */
    use(...l) {
      for (const i of l)
        if (i) {
          if (typeof i != "object" || !("onRequest" in i || "onResponse" in i))
            throw new Error(
              "Middleware must be an object with one of `onRequest()` or `onResponse()`"
            );
          c.push(i);
        }
    },
    /** Unregister middleware */
    eject(...l) {
      for (const i of l) {
        const g = c.indexOf(i);
        g !== -1 && c.splice(g, 1);
      }
    }
  };
}
function A(r, s, e) {
  if (s == null)
    return "";
  if (typeof s == "object")
    throw new Error(
      "Deeply-nested arrays/objects aren’t supported. Provide your own `querySerializer()` to handle these."
    );
  return `${r}=${(e == null ? void 0 : e.allowReserved) === !0 ? s : encodeURIComponent(s)}`;
}
function D(r, s, e) {
  if (!s || typeof s != "object")
    return "";
  const t = [], n = {
    simple: ",",
    label: ".",
    matrix: ";"
  }[e.style] || "&";
  if (e.style !== "deepObject" && e.explode === !1) {
    for (const c in s)
      t.push(
        c,
        e.allowReserved === !0 ? s[c] : encodeURIComponent(s[c])
      );
    const o = t.join(",");
    switch (e.style) {
      case "form":
        return `${r}=${o}`;
      case "label":
        return `.${o}`;
      case "matrix":
        return `;${r}=${o}`;
      default:
        return o;
    }
  }
  for (const o in s) {
    const c = e.style === "deepObject" ? `${r}[${o}]` : o;
    t.push(A(c, s[o], e));
  }
  const a = t.join(n);
  return e.style === "label" || e.style === "matrix" ? `${n}${a}` : a;
}
function B(r, s, e) {
  if (!Array.isArray(s))
    return "";
  if (e.explode === !1) {
    const a = { form: ",", spaceDelimited: "%20", pipeDelimited: "|" }[e.style] || ",", o = (e.allowReserved === !0 ? s : s.map((c) => encodeURIComponent(c))).join(a);
    switch (e.style) {
      case "simple":
        return o;
      case "label":
        return `.${o}`;
      case "matrix":
        return `;${r}=${o}`;
      case "spaceDelimited":
      case "pipeDelimited":
      default:
        return `${r}=${o}`;
    }
  }
  const t = { simple: ",", label: ".", matrix: ";" }[e.style] || "&", n = [];
  for (const a of s)
    e.style === "simple" || e.style === "label" ? n.push(e.allowReserved === !0 ? a : encodeURIComponent(a)) : n.push(A(r, a, e));
  return e.style === "label" || e.style === "matrix" ? `${t}${n.join(t)}` : n.join(t);
}
function U(r) {
  return function(e) {
    const t = [];
    if (e && typeof e == "object")
      for (const n in e) {
        const a = e[n];
        if (a != null) {
          if (Array.isArray(a)) {
            t.push(
              B(n, a, {
                style: "form",
                explode: !0,
                ...r == null ? void 0 : r.array,
                allowReserved: (r == null ? void 0 : r.allowReserved) || !1
              })
            );
            continue;
          }
          if (typeof a == "object") {
            t.push(
              D(n, a, {
                style: "deepObject",
                explode: !0,
                ...r == null ? void 0 : r.object,
                allowReserved: (r == null ? void 0 : r.allowReserved) || !1
              })
            );
            continue;
          }
          t.push(A(n, a, r));
        }
      }
    return t.join("&");
  };
}
function me(r, s) {
  let e = r;
  for (const t of r.match(ye) ?? []) {
    let n = t.substring(1, t.length - 1), a = !1, o = "simple";
    if (n.endsWith("*") && (a = !0, n = n.substring(0, n.length - 1)), n.startsWith(".") ? (o = "label", n = n.substring(1)) : n.startsWith(";") && (o = "matrix", n = n.substring(1)), !s || s[n] === void 0 || s[n] === null)
      continue;
    const c = s[n];
    if (Array.isArray(c)) {
      e = e.replace(
        t,
        B(n, c, { style: o, explode: a })
      );
      continue;
    }
    if (typeof c == "object") {
      e = e.replace(
        t,
        D(n, c, { style: o, explode: a })
      );
      continue;
    }
    if (o === "matrix") {
      e = e.replace(
        t,
        `;${A(n, c)}`
      );
      continue;
    }
    e = e.replace(t, o === "label" ? `.${c}` : c);
  }
  return e;
}
function be(r) {
  return JSON.stringify(r);
}
function we(r, s) {
  var n;
  let e = `${s.baseUrl}${r}`;
  (n = s.params) != null && n.path && (e = me(e, s.params.path));
  let t = s.querySerializer(s.params.query ?? {});
  return t.startsWith("?") && (t = t.substring(1)), t && (e += `?${t}`), e;
}
function z(...r) {
  const s = new Headers();
  for (const e of r) {
    if (!e || typeof e != "object")
      continue;
    const t = e instanceof Headers ? e.entries() : Object.entries(e);
    for (const [n, a] of t)
      if (a === null)
        s.delete(n);
      else if (Array.isArray(a))
        for (const o of a)
          s.append(n, o);
      else
        a !== void 0 && s.set(n, a);
  }
  return s;
}
const [{ variables: R }, { variables: j }] = G ?? [], ge = `${R.scheme.default}://${R.host.default}${R.basePath ? R.basePath.default : ""}`, ke = `${j.scheme.default}://${j.host.default}${j.basePath ? j.basePath.default : ""}`;
class Ae {
  constructor(s) {
    w(this, "sdk");
    w(this, "sdkCloud");
    const e = s.username ?? C.BROWSERSTACK_USERNAME;
    if (s.usernameOptional !== !0 && (typeof e != "string" || !e.trim().length))
      throw new p("Missing options.username");
    const t = s.key ?? C.BROWSERSTACK_KEY;
    if (typeof t != "string" || !t.trim().length)
      throw new p("Missing options.key");
    const n = {
      ...s,
      baseUrl: s.baseUrl ?? ge,
      headers: {
        ...s.headers,
        Authorization: e ? `Basic ${btoa(`${e}:${t}`)}` : void 0,
        "User-Agent": pe.userAgent
      }
    };
    this.sdk = O(n), this.sdkCloud = O({
      ...n,
      baseUrl: ke
    });
  }
  /**
   * @internal
   */
  async makeGetRequest(s, ...e) {
    const t = await this.sdk.GET(s, ...e);
    if (t.error || !t.data)
      throw new p("Request failed", {
        path: s,
        response: t,
        ...e
      });
    return t.data;
  }
  /**
   * @internal
   */
  async makePostRequest(s, ...e) {
    const t = await this.sdk.POST(s, ...e);
    if (t.error || !t.data)
      throw new p("Request failed", {
        path: s,
        response: t,
        ...e
      });
    return t.data;
  }
  /**
   * @internal
   */
  async makeCloudGetRequest(s, ...e) {
    const t = await this.sdkCloud.GET(s, ...e);
    if (t.error || !t.data)
      throw new p("Request failed", {
        path: s,
        response: t,
        ...e
      });
    return t.data;
  }
  /**
   * @internal
   */
  async makeCloudPostRequest(s, ...e) {
    const t = await this.sdkCloud.POST(s, ...e);
    if (t.error || !t.data)
      throw new p("Request failed", {
        path: s,
        response: t,
        ...e
      });
    return t.data;
  }
  /**
   * @internal
   */
  async makePutRequest(s, ...e) {
    const t = await this.sdk.PUT(s, ...e);
    if (t.error || !t.data)
      throw new p("Request failed", {
        path: s,
        response: t,
        ...e
      });
    return t.data;
  }
  /**
   * @internal
   */
  async makePatchRequest(s, ...e) {
    const t = await this.sdk.PATCH(s, ...e);
    if (t.error || !t.data)
      throw new p("Request failed", {
        path: s,
        response: t,
        ...e
      });
    return t.data;
  }
  /**
   * @internal
   */
  async makeDeleteRequest(s, ...e) {
    const t = await this.sdk.DELETE(s, ...e);
    if (t.error || !t.data)
      throw new p("Request failed", {
        path: s,
        response: t,
        ...e
      });
    return t.data;
  }
}
export {
  Ae as A,
  p as B,
  Re as a,
  je as c,
  C as e
};
